package org.dromara.system.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.system.domain.bo.SiteBagBo;
import org.dromara.system.domain.vo.SiteBagVo;
import org.dromara.system.domain.SiteBag;
import org.dromara.system.mapper.SiteBagMapper;
import org.dromara.system.service.ISiteBagService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author Lion Li
 * @date 2024-10-31
 */
@RequiredArgsConstructor
@Service
public class SiteBagServiceImpl implements ISiteBagService {

    private final SiteBagMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     */
    @Override
    public SiteBagVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public TableDataInfo<SiteBagVo> queryPageList(SiteBagBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SiteBag> lqw = buildQueryWrapper(bo);
        Page<SiteBagVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询【请填写功能名称】列表
     */
    @Override
    public List<SiteBagVo> queryList(SiteBagBo bo) {
        LambdaQueryWrapper<SiteBag> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SiteBag> buildQueryWrapper(SiteBagBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SiteBag> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getBagCompany()), SiteBag::getBagCompany, bo.getBagCompany());
        lqw.eq(StringUtils.isNotBlank(bo.getBagNumber()), SiteBag::getBagNumber, bo.getBagNumber());
        lqw.eq(StringUtils.isNotBlank(bo.getBagStatus()), SiteBag::getBagStatus, bo.getBagStatus());
        lqw.eq(bo.getBagOutTime() != null, SiteBag::getBagOutTime, bo.getBagOutTime());
        lqw.eq(StringUtils.isNotBlank(bo.getBagLocal()), SiteBag::getBagLocal, bo.getBagLocal());
//        lqw.eq(StringUtils.isNotBlank(bo.getBagLocal2()), SiteBag::getBagLocal2, bo.getBagLocal2());
        lqw.eq(bo.getBagInTime() != null, SiteBag::getBagInTime, bo.getBagInTime());
        lqw.eq(StringUtils.isNotBlank(bo.getBagReason()), SiteBag::getBagReason, bo.getBagReason());
        lqw.eq(StringUtils.isNotBlank(bo.getBagSite()), SiteBag::getBagSite, bo.getBagSite());
        lqw.eq(bo.getUpdatedAt() != null, SiteBag::getUpdatedAt, bo.getUpdatedAt());
        lqw.eq(bo.getCreatedAt() != null, SiteBag::getCreatedAt, bo.getCreatedAt());
        if(params.containsKey("beginCreatedAt")){
            lqw.between(SiteBag::getCreatedAt, (String) params.get("beginCreatedAt"), (String) params.get("endCreatedAt"));
        }
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     */
    @Override
    public Boolean insertByBo(SiteBagBo bo) {
        SiteBag add = MapstructUtils.convert(bo, SiteBag.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     */
    @Override
    public Boolean updateByBo(SiteBagBo bo) {
        SiteBag update = MapstructUtils.convert(bo, SiteBag.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SiteBag entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除【请填写功能名称】
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
